	list	p=16F628
	#include p16F628.inc
;(1) LE MOT DE CONFIGURATION
	__CONFIG  _XT_OSC&_WDT_OFF&_LVP_OFF	
OCTET	EQU	H'0020'
MEM_SERV	EQU	H'0021'
ANGLE	EQU	H'0022'
SAV_W	EQU	H'0023'
SAV_STATUS	EQU	H'0024'
SAV_FSR	EQU	H'0025'
NMR_SERVO	EQU	H'0026'
SORTIE	EQU	H'0027'
J	EQU	H'0028'
I	EQU	H'0029'
VARIF	EQU	H'002A'
VBFOR1	EQU	H'002B'
OPER_1	EQU	H'002C'
OPER_2	EQU	H'002D'
RESULT	EQU	H'002E'
RESTE	EQU	H'002F'
VBFOR2	EQU	H'0030'
;(2) TIQUETTES ET VARIABLES
BR_REC	EQU 2
	ORG 0
	GOTO	INIT
;(3 LE SOUS-PROGRAMME DE TRAITEMENT DES INTERRUPTIONS
	ORG 4
	CALL SAV_REG
;(4) VOIR SI INTERRUPTION DU TIMER1 OU TIMER0
	BTFSS	PIR1,TMR1IF		
	GOTO	INT_TMR0
;(5) SI INTERRUPTION PAR TIMER1
	MOVLW	H'F7'
	MOVWF	TMR1H
	MOVLW	H'4F'
	MOVWF	TMR1L
	BCF PIR1, TMR1IF
; DEBUT DE CRENEAUX
	MOVLW	H'00'
	MOVWF	PORTB
	BCF STATUS,C
	RLF SORTIE,1
	INCF NMR_SERVO,1
	MOVF	NMR_SERVO,0
	SUBLW	H'A8'
	BTFSS	STATUS,Z
	GOTO	ELSE1
	MOVLW	H'A0'
	MOVWF	NMR_SERVO
	MOVLW	H'01'
	MOVWF	SORTIE
ELSE1	NOP
	MOVF	SORTIE,0
	MOVWF	PORTB
	MOVF	NMR_SERVO,0
	MOVWF	FSR
	MOVF	INDF,0
	MOVWF	TMR0
	BSF INTCON,T0IE          ;AUTORISATION INTSUR TMR0
	BCF INTCON,T0IF
	GOTO	FIN_INT
;(6) SI INTERRUPTION PAR TIMER0
INT_TMR0	MOVLW	H'00'
	MOVWF	PORTB
	BCF INTCON,T0IE
	BCF INTCON,T0IF
FIN_INT	CALL RAP_REG		
	RETFIE
;(7) INITIALISATION
INIT	MOVLW	H'07'
	MOVWF	CMCON
	BSF STATUS, RP0
	MOVLW	H'04'
	MOVWF	TRISA
	MOVLW	H'00'
	MOVWF	TRISB
	MOVLW	H'82'
	MOVWF	OPTION_REG
	BSF PIE1,TMR1IE
	BCF STATUS, RP0
	MOVLW	H'01'
	MOVWF	T1CON
	MOVLW	H'A0'
	MOVWF	FSR
	SUBLW	H'A7'
	MOVWF	VBFOR1
	INCF	VBFOR1,1
SP_FOR1	NOP
	MOVLW	H'43'
	MOVWF	INDF
	INCF	FSR,1
	DECFSZ	VBFOR1,1
	GOTO	SP_FOR1
	MOVLW	H'A0'
	MOVWF	NMR_SERVO
	MOVLW	H'01'
	MOVWF	SORTIE
	BSF INTCON,PEIE
	BSF INTCON,GIE
;(8) LA BOUCLE DU PROGRAMME PRINCIPAL 	
DEB	CALL	REC
	MOVF	OCTET,0
	SUBLW	H'53'
	BTFSC	STATUS,Z
	GOTO	ELSE2
	GOTO	DEB
ELSE2	NOP
	CALL	REC
	MOVF	OCTET,0
	SUBLW	H'37'
	BTFSC	STATUS,C
	GOTO	ELSE3
	GOTO	DEB
ELSE3	NOP
	MOVF	OCTET,0
	MOVWF	VARIF
	MOVLW	H'30'
	SUBWF	VARIF,0
	BTFSC	STATUS,C
	GOTO	ELSE4
	GOTO	DEB
ELSE4	NOP
	MOVF	OCTET,0
	ADDLW	H'70'
	MOVWF	MEM_SERV
	CALL	REC
	MOVF	OCTET,0
	SUBLW	H'31'
	BTFSC	STATUS,C
	GOTO	ELSE5
	GOTO	DEB
ELSE5	NOP
	MOVF	OCTET,0
	MOVWF	VARIF
	MOVLW	H'30'
	SUBWF	VARIF,0
	BTFSC	STATUS,C
	GOTO	ELSE6
	GOTO	DEB
ELSE6	NOP
	MOVLW	H'30'
	SUBWF	OCTET,0
	MOVWF	OCTET
	CLRF	RESULT
	MOVF	OCTET,0
	MOVWF	OPER_1
	MOVLW	H'64'
	MOVWF	OPER_2
	CALL	MUL_OP
	MOVF	RESULT, 0
	MOVWF	ANGLE
	CALL	REC
	MOVF	OCTET,0
	SUBLW	H'39'
	BTFSC	STATUS,C
	GOTO	ELSE7
	GOTO	DEB
ELSE7	NOP
	MOVF	OCTET,0
	MOVWF	VARIF
	MOVLW	H'30'
	SUBWF	VARIF,0
	BTFSC	STATUS,C
	GOTO	ELSE8
	GOTO	DEB
ELSE8	NOP
	MOVLW	H'30'
	SUBWF	OCTET,0
	MOVWF	OCTET
	CLRF	RESULT
	MOVF	OCTET,0
	MOVWF	OPER_1
	MOVLW	H'0A'
	MOVWF	OPER_2
	CALL	MUL_OP
	MOVF	RESULT, 0
	MOVWF	OCTET
	MOVF	ANGLE,0
	ADDWF	OCTET,0
	MOVWF	ANGLE
	CALL	REC
	MOVF	OCTET,0
	SUBLW	H'39'
	BTFSC	STATUS,C
	GOTO	ELSE9
	GOTO	DEB
ELSE9	NOP
	MOVF	OCTET,0
	MOVWF	VARIF
	MOVLW	H'30'
	SUBWF	VARIF,0
	BTFSC	STATUS,C
	GOTO	ELSE10
	GOTO	DEB
ELSE10	NOP
	MOVLW	H'30'
	SUBWF	OCTET,0
	MOVWF	OCTET
	MOVF	MEM_SERV,0
	MOVWF	FSR
	MOVF	ANGLE,0
	ADDWF	OCTET,0
	MOVWF	INDF
	GOTO	DEB
;(9) SOUS-PROGRAMME DE RECEPTION
REC	CLRF OCTET
ATTREC	BTFSC PORTA,BR_REC
	GOTO	ATTREC
	CALL	PAUSE1250
	MOVLW	H'01'
	MOVWF	J
	SUBLW	H'08'
	MOVWF	VBFOR2
	INCF	VBFOR2,1
SP_FOR2	NOP
	BCF STATUS,C
	BTFSC PORTA,BR_REC
	BSF STATUS,C
	RRF OCTET,1
	CALL	PAUSE833
	INCF	J,1
	DECFSZ	VBFOR2,1
	GOTO	SP_FOR2
	RETURN
;(10) SOUS-PROGRAMME DE SAUVEGARDE 
SAV_REG MOVWF SAV_W  ;SAUVEGARDE W DANS SAV_W
	 SWAPF	STATUS,0  ;SAUVEGARDE STATUS
	 MOVWF SAV_STATUS  ;DANS SAV_STATUS
	MOVF	FSR,0
	MOVWF	SAV_FSR
	RETURN
;(11) SOUS-PROGRAMME DE RESTITUTION
RAP_REG	MOVF	SAV_FSR,0
	MOVWF	FSR
	SWAPF SAV_STATUS,0  ; RESTAURATION STATUS
	MOVWF STATUS
	SWAPF SAV_W,1  ; RESTAURATION DE W
	SWAPF SAV_W,0			
	RETURN
;(12) SOUS-PROGRAMME D'ATTENTE DE 1250 MICROSEC 
PAUSE1250	MOVLW	H'F9'
	MOVWF	I
SP1250	NOP
	NOP
	DECFSZ I,1
	GOTO	SP1250
	RETURN
;(13) SOUS-PROGRAMME D'ATTENTE DE 833 MICROSEC 
PAUSE833	MOVLW	H'CE'
	MOVWF	I
SP833	NOP
	DECFSZ I,1
	GOTO	SP833
	RETURN
MUL_OP	BTFSC STATUS, Z
	RETURN
	MOVF	OPER_1, 0
	ADDWF	RESULT, 1
	DECF	OPER_2, 1
	GOTO	MUL_OP
	NOP
	END
